﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Mogre;

namespace TppGame
{
    public class CharacterAnimBlender : AnimBlender
    {
        public static string[] MaskLegs = 
        { "Main", "Leg1.L", "Leg1.R", "Leg2.L", "Leg2.R", "Leg3.L", "Leg3.R", 
            "Foot.L", "Foot.R",  "SwordSheath" };
        public static string[] MaskTorso =
        { "Spine1", "Spine2", "Spine3", "Arm1.L", "Arm1.R", "Arm2.L", "Arm2.R", 
            "Arm3.L", "Arm3.R", "Arm4.L", "Arm4.R", "Hand1.L", "Hand1.R", "Hand2.L", 
            "Hand2.R", "Hand3.L", "Hand3.R", "Hand4.L", "Hand4.R", "Thumb1.L", 
            "Thumb1.R", "Thumb2.L", "Thumb2.R", "Thumb3.L", "Thumb3.R", "Thumb1.L",
            "Neck", "HeadFront", "Head", "Jaw", "Mouth.L", "Mouth.R", 
            "LongswordSheath", "Sword" };

        public CharacterAnimBlender()
            : base()
        {
            AddGroup("Legs", MaskLegs);
            AddGroup("Torso", MaskTorso);

            RegisterAnim("IdleLegs");
            RegisterAnim("IdleTorso");
            RegisterAnim("WalkLegs");
            RegisterAnim("WalkTorso");            
            RegisterAnim("PickItemDownLegs", false);
            RegisterAnim("PickItemDownTorso", false);

            RegisterSet("Idle", "IdleLegs", "IdleTorso");
            RegisterSet("Walk",  "WalkLegs", "WalkTorso" );            
            RegisterSet("PickItemDown", "PickItemDownLegs", "PickItemDownTorso");

            RegisterLink("WalkLegs", "WalkTorso");
            RegisterLink( "IdleLegs", "IdleTorso");

            Groups["Legs"].AddAnim("IdleLegs");
            Groups["Torso"].AddAnim("IdleTorso");
            Groups["Legs"].AddAnim("PickItemDownLegs");
            Groups["Torso"].AddAnim("PickItemDownTorso");            
            Groups["Legs"].AddAnim("WalkLegs");
            Groups["Torso"].AddAnim("WalkTorso");

            DefaultAnimSetName = "Idle";
        }                
    }
}
