﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TppGame
{
    static class Conversations
    {
        public static TalkReaction ConversationRoot;
        static TalkNode FirstGreeting;
        static TalkReply WhereIAm;
        static TalkReaction RespWhatIsIt;
        static TalkNode ItIsATest;
        static TalkReply IDontWantToBother;
        static TalkReply Ending;
        static TalkNode HelloAgain;

        public static bool FirstTalk = true;                  

        static Conversations()
        {
            ConversationRoot = new TalkReaction();

            FirstGreeting = new TalkNode();

            TalkEdge firstTalkEdge = new TalkEdge(FirstGreeting);
            firstTalkEdge.Conditions += (() => FirstTalk);
            ConversationRoot.Edges.Add(firstTalkEdge);

            FirstGreeting.Text.Add(new TalkText("Welcome stranger! What can I do for you?", 3.0f));
            FirstGreeting.Actions += (() => FirstTalk = false);
                                      
            HelloAgain = new TalkNode();
            HelloAgain.Text.Add(new TalkText("Hello again!", 1.0f));
            ConversationRoot.Edges.Add(new TalkEdge(HelloAgain));

            WhereIAm = new TalkReply();
            WhereIAm.Text.Add(new TalkText("What is this place? Where I am?", 3.0f));
            FirstGreeting.Replies.Add(WhereIAm);
            HelloAgain.Replies.Add(WhereIAm);

            IDontWantToBother = new TalkReply();
            IDontWantToBother.Text.Add(new TalkText("I don't want to bother you, bye.", 2.5f));
            IDontWantToBother.IsEnding = true;
            FirstGreeting.Replies.Add(IDontWantToBother);
            HelloAgain.Replies.Add(IDontWantToBother);

            ItIsATest = new TalkNode();
            ItIsATest.Text.Add(new TalkText("It is a test level of The Game.", 2.0f));
            ItIsATest.Text.Add(new TalkText("Be my guest.", 2.0f));

            RespWhatIsIt = new TalkReaction();
            RespWhatIsIt.Edges.Add(new TalkEdge(ItIsATest));

            WhereIAm.Reaction = RespWhatIsIt;

            Ending = new TalkReply();
            Ending.Text.Add(new TalkText("Thanks, bye.", 1.5f));
            Ending.IsEnding = true;

            ItIsATest.Replies.Add(Ending);
        }
    }
}
