﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TppGame.DecTree
{
    public class Works : Node
    {
        public Action<Character> OnFail;

        public int LastBusy;
        public int LastVisitTime;
        public override Status Visit(Character ch)
        {                       
            //if (Engine.Singleton.
            for (int i = 0; i < Children.Count; i++)
            {
                if (i >= LastBusy || Children[i] is Assert)
                {
                    Status status = Children[i].Visit(ch);
                    if (status == Status.Busy)
                    {
                        LastBusy = i;
                        return status;
                    }
                    else if (status == Status.Fail)
                    {
                        if (OnFail != null)
                            OnFail(ch);
                        LastBusy = 0;                        
                        return status;
                    }
                }
            }
            LastBusy = 0;
            return Status.Success;
        }
    }
}
